<?php    

    require_once 'model/clientes.entidad.php';
    require_once 'model/clientes.model.php';
    require_once 'model/cliente_contacto.entidad.php';
    require_once 'model/cliente_contacto.model.php';
    require_once 'model/usuario.entidad.php';
    require_once 'model/usuario.model.php';
    require_once 'model/parametro.model.php';
    require_once 'model/parametro.entidad.php';
    require_once 'model/apoderado.model.php';
    require_once 'model/apoderado.entidad.php';
    require_once 'view/librerias/PHPExcel/PHPExcel.php';
    ini_set('max_execution_time', 500); 
    class ClienteController extends helpers{
        private $clientes_model;
        private $clientes_contacto_model;
        private $usuario_model;
        private $parametro_model;
        private $apoderado_model;
        private $objPHPExcel;
        public function __CONSTRUCT(){
            $this->clientes_model = new ClientesModel();
            $this->clientes_contacto_model = new Cliente_contactoModel();
            $this->usuario_model = new UsuarioModel();
            $this->parametro_model = new ParametroModel();
            $this->apoderado_model = new ApoderadoModel();
            $this->objPHPExcel = new PHPExcel();
        }
        
        public function Index(){
            $parametro = $this->parametro_model->ListarParametros();
            $clientes= $this->clientes_model->Listar();
            require_once 'view/header.php';  
            require_once 'view/webforms/wfacliente.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }
        public function FrmGuardarCliente(){
            require_once 'view/webforms/wfaclientea.php'; 
        }
        
        public function FrmEditarCliente(){
            $datos = $this->clientes_model->Buscar($_POST['Cliente_Id']);            
            foreach ($datos as $r):
                require_once 'view/webforms/wfaclientea.php';            
            endforeach;    
        }
        
        public function MostrarCliente(){
            $datos = $this->clientes_model->Buscar($_POST['Cliente_Id']);
            foreach ($datos as $r):
                echo " <tbody>
                              <tr>
                                 <td>
                                    <input type='hidden' name='idCliente_Print' id='idCliente_Print' value='" . $r->__GET('Cliente_Id') . "'> 
                                    Codigo SAP
                                 </td>
                                 <td>" . $r->__GET('sCliCodigoSAP') . "</td>
                              </tr>
                              <tr>
                                 <td>Nombre/Razon social</td>
                                 <td>" . $r->__GET('sCliNombre') . "</td>
                              </tr>  
                              <tr>
                                 <td>RUC/DNI</td>
                                 <td>" . $r->__GET('sCliRUCDNI') . "</td>
                              </tr>  
                              <tr>
                                 <td>Telefono 1</td>
                                 <td>" . $r->__GET('sCliTelefono') . "</td>
                              </tr>  
                              <tr>
                                 <td>Telefono 2</td>
                                 <td>" . $r->__GET('sCliTelefono2') . "</td>
                              </tr>   
                              <tr>
                                 <td>Codigo Pais</td>
                                 <td>" . $r->__GET('sCliCodPais') . "</td>
                              </tr>    
                              <tr>
                                 <td>Pais</td>
                                 <td>" . $r->__GET('sCliPais') . "</td>
                              </tr>   
                              <tr>
                                 <td>Departamento</td>
                                 <td>" . $r->__GET('sCliDepartamento') . "</td>
                              </tr>  
                              <tr>
                                 <td>Provincia</td>
                                 <td>" . $r->__GET('sCliProvincia') . "</td>
                              </tr>  
                              <tr>
                                 <td>Distrito</td>
                                 <td>" . $r->__GET('sCliDistrito') . "</td>
                              </tr>
                              <tr>
                                 <td>Dirección</td>
                                 <td>" . $r->__GET('sCliDireccion') . "</td>
                              </tr>
                              <tr>
                                 <td>Usuario</td>
                                 <td>" . $r->__GET('sCliUsuario') . "</td>
                              </tr>
                              <tr>
                                 <td>Grupo</td>
                                 <td>" . $r->__GET('sCliGrupoCli') . "</td>
                              </tr>
                              <tr>
                                 <td>Estado</td>
                                 <td>" . ($r->__GET('nCliEstado') == 0 ? '<span class="label label-danger">Deshabilitado</span>' : '<span class="label label-success">Habilitado</span>') . "</td>
                              </tr>
                              <tr>
                        <td colspan='2'style='width: 100%;'>
                            <h5>APODERADOS</h5>
                            <hr style='margin-bottom: 5px; margin-top: 5px;'>
                            <table class='table table-striped text-center' style='width: 100%;' cellpadding='0' cellspacing='0'>
                                <thead>
                                    <tr>
                                        <th style='width: 30%;'>NOMBRE</th>
                                        <th style='width: 20%;'>CARGO</th>
                                        <th style='width: 30%;'>CORREO</th>
                                        <th style='width: 20%;'>MOVIL</th>
                                    </tr>                                
                                </thead>
                                <tbody>";

                $contactos = $this->clientes_contacto_model->Buscar($r->__GET('Cliente_Id'));
                if(count($contactos) > 0){
                    foreach ($contactos as $apo) {

                        echo "    <tr>
                                    <td>" . $apo->__GET("sCliConNombre") . "</td>
                                    <td>" . $apo->__GET("sCliConCargo") . "</td>
                                    <td>" . $apo->__GET("sCliConCorreo") . "</td>
                                    <td>" . $apo->__GET("sCliConMovil") . "</td>
                                </tr>";
                    }
                } else {
                    
                    echo '<tr><td colspan="5">NO EXISTE DATOS</td></tr>';
                    
                }
                echo '<tbody></table></td></tr>';
               echo '</tbody>';
            endforeach;
        }
        public function GuardarCliente(){
            $cli = new Clientes();
            if($_POST['Cliente_Id'] != 0 ? $cli->__SET('Cliente_Id', $this->str_uppercase($_POST['Cliente_Id'])) : '');
            $cli->__SET('sCliCodigoSAP', $this->str_uppercase($_POST['sCliCodigoSAP']));
            $cli->__SET('sCliNombre', $this->str_uppercase($_POST['sCliNombre']));
            $cli->__SET('sCliRUCDNI', $this->str_uppercase($_POST['sCliRUCDNI']));
            $cli->__SET('sCliTelefono', $this->str_uppercase($_POST['sCliTelefono']));
            $cli->__SET('sCliTelefono2', $this->str_uppercase($_POST['sCliTelefono2']));
            $cli->__SET('sCliCodPais', $this->str_uppercase($_POST['sCliCodPais']));
            $cli->__SET('sCliPais', $this->str_uppercase($_POST['sCliPais']));
            $cli->__SET('sCliDepartamento', $this->str_uppercase($_POST['sCliDepartamento']));
            $cli->__SET('sCliProvincia', $this->str_uppercase($_POST['sCliProvincia']));
            $cli->__SET('sCliDistrito', $this->str_uppercase($_POST['sCliDistrito']));
            $cli->__SET('sCliDireccion', $this->str_uppercase($_POST['sCliDireccion']));
            $cli->__SET('sCliUsuario', $this->str_uppercase($_POST['sCliUsuario']));
            $cli->__SET('sCliPassword', $_POST['sCliPassword']);
            $cli->__SET('sCliGrupoCli', $this->str_uppercase($_POST['sCliGrupoCli']));
            $cli->__SET('nCliEstado', $this->str_uppercase($_POST['nCliEstado']));
            $cli->__SET('nCliOculto', 0);
            $cli->__SET('nCliUsuario_Id', $_SESSION['usu_codigo']);
            
            if($_POST['Cliente_Id'] != 0){
                
                $this->clientes_model->Editar($cli);
                
                $cont = new Cliente_contacto();
                $cont->__SET("Cliente_Id", $_POST['Cliente_Id']);
                $this->clientes_contacto_model->Eliminar($cont);
                
            } else {
                
                $Cliente_Id = $this->clientes_model->Crear($cli);  
                
            }
            
            $contactos = json_decode($_POST['Contactos']);
                
            for ($i = 0; $i < count($contactos); $i++) {

                $cont = new Cliente_contacto();
                $cont->__SET("Cliente_Id", ($_POST['Cliente_Id'] != 0 ? $_POST['Cliente_Id'] : $Cliente_Id));
                $cont->__SET("sCliConNombre", $contactos[$i]->sCliConNombre);
                $cont->__SET("sCliConCargo", $contactos[$i]->sCliConCargo);
                $cont->__SET("sCliConCorreo", $contactos[$i]->sCliConCorreo);
                $cont->__SET("sCliConMovil", $contactos[$i]->sCliConMovil);
                $this->clientes_contacto_model->Crear($cont);

            }
            
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    '. ($_POST['Cliente_Id'] != 0 ? 'Se modifico correctamente.' : 'Se guardo correctamente.') .'
                  </div>';
            
        }
        public function EliminarCliente(){
            $cli = new Clientes();
            $cli->__SET('Cliente_Id', $_POST['idCliente']);
            $this->clientes_model->Eliminar($cli);
            echo '<script type="text/javascript">window.location="?c=Cliente&a=Index";</script>';
            
        }

        public function PDFCliente(){            
            require_once 'view/webforms/PDF/cliente.php';
        }
        public function ListarContactos(){
            
            $contactos = $this->clientes_contacto_model->Buscar($_POST['Cliente_Id']);
            
            $array = [];
            
            foreach ($contactos as $r):
                
                $array[] = array(
                    'cliente_contacto_Id' => $r->cliente_contacto_Id,
                    'Cliente_Id' => $r->Cliente_Id,
                    'sCliConNombre' => $r->sCliConNombre,
                    'sCliConCargo' => $r->sCliConCargo,
                    'sCliConCorreo' => $r->sCliConCorreo,
                    'sCliConMovil' => $r->sCliConMovil
                );
                
            endforeach;
            
            print_r(json_encode($array));
            
        }
        
        public function ImportarExcel(){
            
            if(substr($_FILES['excel_clientes']['name'], -4) == "xlsx"){
            
                $fecha = date("y-m-d");
                $carpeta = "view/librerias/excel/";
                $excel = $fecha."-".$_FILES["excel_clientes"]["name"];
                move_uploaded_file($_FILES["excel_clientes"]["tmp_name"], $carpeta.$excel);

                $pathInfo = pathinfo($carpeta.$excel);

                $type = $pathInfo['extension'] == 'xlsx' ? 'Excel2007' : 'Excel5';

                $objReader = PHPExcel_IOFactory::createReader($type);

                $objPHPExcel = $objReader->load($carpeta.$excel);

                foreach ($objPHPExcel->getWorksheetIterator() as $worksheet) {

                    $worksheets[$worksheet->getTitle()] = $worksheet->toArray();

                }
                if(isset($worksheets["Sheet1"])){
                    
                    $data = $worksheets["Sheet1"];
                    
                    for ($i = 0; $i < count($data); $i++) {
                        
                        $json = $data[$i];
                        
                        $verificar = $this->clientes_model->Verificar($json[0]);
                        
                        if(count($verificar) == 0){
                            
                            $cli = new Clientes();
                            $cli->__SET('sCliCodigoSAP', $json[0]);
                            $cli->__SET('sCliNombre', $json[1]);
                            $cli->__SET('sCliRUCDNI', $json[11]);
                            $cli->__SET('sCliTelefono', $json[2]);
                            $cli->__SET('sCliTelefono2', $json[2]);
                            $cli->__SET('sCliCodPais', $json[4]);
                            $cli->__SET('sCliPais', $json[5]);
                            $cli->__SET('sCliDepartamento', $json[6]);
                            $cli->__SET('sCliProvincia', $json[7]);
                            $cli->__SET('sCliDistrito', $json[8]);
                            $cli->__SET('sCliDireccion', $json[9]);
                            $cli->__SET('sCliUsuario', "");
                            $cli->__SET('sCliPassword',"");
                            $cli->__SET('sCliGrupoCli', $json[10]);
                            $cli->__SET('nCliEstado', 1);
                            $cli->__SET('nCliOculto', 0);
                            $cli->__SET('nCliUsuario_Id', $_SESSION['usu_codigo']);

                            $Cliente_Id = $this->clientes_model->Crear($cli);  

                            if($json[12] != ""){

                                $cont = new Cliente_contacto();
                                $cont->__SET("Cliente_Id", $Cliente_Id);
                                $cont->__SET("sCliConNombre", $json[12]);
                                $cont->__SET("sCliConCargo", "");
                                $cont->__SET("sCliConCorreo", $json[14]);
                                $cont->__SET("sCliConMovil", "");
                                $this->clientes_contacto_model->Crear($cont);

                            }

                            if($json[13] != ""){

                                $cont1 = new Cliente_contacto();
                                $cont1->__SET("Cliente_Id", $Cliente_Id);
                                $cont1->__SET("sCliConNombre", $json[13]);
                                $cont1->__SET("sCliConCargo", "");
                                $cont1->__SET("sCliConCorreo", $json[14]);
                                $cont1->__SET("sCliConMovil", "");
                                $this->clientes_contacto_model->Crear($cont1);

                            }
                            
                        }
                        
                    }
                    
                    echo "Datos guardados";
                    echo '<script type="text/javascript">window.location="?c=Cliente&a=Index";</script>';
                    
                }
                
            }
            
            echo '<script type="text/javascript">window.location="?c=Cliente&a=Index";</script>';
                
//print_r();
            
            
//            $fecha = date("y-m-d");
//            $carpeta = "view/librerias/excel/";
//            $excel = $fecha."-".$_FILES["excel_clientes"]["name"];
//            move_uploaded_file($_FILES["excel_clientes"]["tmp_name"], $carpeta.$excel);
//            
//            $row = 1;
//            
//            $fp = fopen($carpeta.$excel, "r");
//            
//            while ($data = fgetc($fp, 1000, ",")){
//                echo $data[0];
//            }
//            
//            echo substr($_FILES["excel_clientes"]["name"], -3);
            
        }
        public function JsonDatosCliente(){
            
            $datos = $this->clientes_model->Buscar($_POST["Cliente_Id"]);            
            foreach ($datos as $r):
                print_r(json_encode(array(
                    'Cliente_Id' => $r->Cliente_Id,
                    'sCliCodigoSAP' => $r->sCliCodigoSAP,
                    'sCliNombre' => $r->sCliNombre,
                    'sCliRUCDNI' => $r->sCliRUCDNI,
                    'sCliTelefono' => $r->sCliTelefono,
                    'sCliTelefono2' => $r->sCliTelefono2,
                    'sCliCodPais' => $r->sCliCodPais,
                    'sCliPais' => $r->sCliPais,
                    'sCliDepartamento' => $r->sCliDepartamento,
                    'sCliProvincia' => $r->sCliProvincia,
                    'sCliDistrito' => $r->sCliDistrito,
                    'sCliDireccion' => $r->sCliDireccion,
                    'sCliUsuario' => $r->sCliUsuario,
                    'sCliPassword' => $r->sCliPassword,
                    'sCliGrupoCli' => $r->sCliGrupoCli,
                    'nCliEstado' => $r->nCliEstado,
                    'nCliOculto' => $r->nCliOculto,
                    'dCliFecha_Act' => $r->dCliFecha_Act,
                    'nCliUsuario_Id' => $r->nCliUsuario_Id
                )));
            endforeach;    
        }
    }
?>