<?php
class Cliente_contactoModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL cli_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $cli = new Cliente_contacto();
                $cli->__SET('cliente_contacto_Id', $r->cliente_contacto_Id);
                $cli->__SET('Cliente_Id', $r->Cliente_Id);
                $cli->__SET('sCliConNombre', $r->sCliConNombre);
                $cli->__SET('sCliConCargo', $r->sCliConCargo);
                $cli->__SET('sCliConCorreo', $r->sCliConCorreo);
                $cli->__SET('sCliConMovil', $r->sCliConMovil);
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Buscar($Clientes_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL clicot_listar($Clientes_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $cli = new Cliente_contacto();
                $cli->__SET('cliente_contacto_Id', $r->cliente_contacto_Id);
                $cli->__SET('Cliente_Id', $r->Cliente_Id);
                $cli->__SET('sCliConNombre', $r->sCliConNombre);
                $cli->__SET('sCliConCargo', $r->sCliConCargo);
                $cli->__SET('sCliConCorreo', $r->sCliConCorreo);
                $cli->__SET('sCliConMovil', $r->sCliConMovil);
                $result[] = $cli;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Crear(Cliente_contacto $data){
        try {
            $stm = $this->pdo->prepare("CALL clicot_crear(?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('Cliente_Id'),
                                 $data->__get('sCliConNombre'),
                                 $data->__get('sCliConCargo'),
                                 $data->__get('sCliConCorreo'),
                                 $data->__get('sCliConMovil')
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(Cliente_contacto $data){
        try {
            $stm = $this->pdo->prepare("CALL cli_editar(?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('Cliente_Id'),
                                 $data->__get('sCliConNombre'),
                                 $data->__get('sCliConCargo'),
                                 $data->__get('sCliConCorreo'),
                                 $data->__get('sCliConMovil'),
                                 $data->__get('cliente_contacto_Id')
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Cliente_contacto $data){
        try {
             $stm = $this->pdo->prepare("CALL clicot_eliminar(?)");
             $stm->execute(array($data->__get('Cliente_Id')));
        } catch (Exception $e) {
             echo die($e->getMessage());
        }
   }
}
?>
