<?php
class EvaluaciondetalleModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function GuardarDet(Evaluaciondetalle $data){
        try {
            $stm = $this->pdo->prepare("CALL evadet_crear(?,?,?,?,?,?,?,?,@evaluaciondetalle_Id)");
            $stm->execute(array(
                                 $data->__get('nEvaDetEvaluacion_Id'),
                                 $data->__get('nEvaDetEvaluado_Id'),
                                 $data->__get('nEvaDetEvaluador_Id'),
                                 $data->__get('nEvaDetTipo'),
                                 $data->__get('nEvaDetCuestionario_Id'),
                                 $data->__get('nEvaDetEstado'),
                                 $data->__get('nEvaDetAvance'),
                                 $data->__get('nEvaDetUsuario_Id')
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    //guardar el detalle autogenerado de padres e hijos

    public function GuardarDetPadreHijo(Evaluaciondetalle $data){
        try {
            $stm = $this->pdo->prepare("CALL evadet_generar(?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('nEvaDetEvaluacion_Id'),
                                 $data->__get('Organigrama_Id'), // el evaluado
                                 $data->__get('OrgCat_Id'),
                                 $data->__get('nEvaDetCuestionario_Id'),
                                 $data->__get('nEvaDetUsuario_Id')
                                 ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Buscar($evaluacion_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL evadet_listar($evaluacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $pro = array(
                    'evaluaciondetalle_Id' => $r->evaluaciondetalle_Id,
                    'nEvaDetEvaluacion_Id' => $r->nEvaDetEvaluacion_Id,
                    'nEvaDetEvaluado_Id' => $r->nEvaDetEvaluado_Id,
                    // 'nEvaDetTipo' => $r->nEvaDetTipo,
                    'Evaluado' => $r->Evaluado,
                    'nEvaDetEvaluador_Id' => $r->nEvaDetEvaluador_Id,
                    'Evaluador' => $r->Evaluador,
                    'nEvaDetCuestionario_Id' => $r->nEvaDetCuestionario_Id,
                    'Cuestionario' => $r->Cuestionario,

                    'PuestoEvaluador' => $r->PuestoEvaluador,
                    'PuestoEvaluado' => $r->PuestoEvaluado,
                    'Tipo' => $r->Tipo,
                );
                $result[] = $pro;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Evaluaciondetalle $data){
        try {
             $stm = $this->pdo->prepare("DELETE FROM evaluaciondetalle WHERE evaluaciondetalle_Id = ? ");
             $stm->execute(array($data->__get('evaluaciondetalle_Id')));
        } catch (Exception $e) {
             echo die($e->getMessage());
        }
    }
}
?>
