<?php
class ReporteModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar()");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar resultados por fecha
    public function ListarDate($fechaInicio, $fechaFin){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL res_listarevaluadosAll('".date('Y-m-d', strtotime($fechaInicio))."','".date('Y-m-d', strtotime($fechaFin))."')");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $mov = new Resultado();
                $mov->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $mov->__SET('Fecha', date('d-m-Y', strtotime($r->Fecha)));
                $mov->__SET('Evaluador_Id', $r->Evaluador_Id);
                $mov->__SET('Evaluado_Id', $r->Evaluado_Id);
                $mov->__SET('cuestionario_Id', $r->cuestionario_Id);
                $mov->__SET('PuestoEvaluador', $r->PuestoEvaluador);
                $mov->__SET('PuestoEvaluado', $r->PuestoEvaluado);
                $mov->__SET('Evaluador', $r->Evaluador);
                $mov->__SET('Evaluado', $r->Evaluado);
                $mov->__SET('Evaluacion', $r->Evaluacion);
                $mov->__SET('Cuestionario', $r->Cuestionario);
                $mov->__SET('Estado', $r->Estado);
                $mov->__SET('resultado_Id', $r->resultado_Id);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function ClaveAnterior($Usuario_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL usu_claveAnterior($Usuario_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    
    }

    //listar reporte por fecha en el principal
    public function ListarConsolidado($fechaInicio, $fechaFin){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL res_Consolidado('".date('Y-m-d', strtotime($fechaInicio))."','".date('Y-m-d', strtotime($fechaFin))."')");
            // $stm = $this->pdo->prepare("CALL res_Consolidado('2024-01-01','2024-12-31')");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $mov = new Reporte();
                $mov->__SET('Personal_Id', $r->Personal_Id);
                $mov->__SET('Evaluacion_Id', $r->Evaluacion_Id);
                $mov->__SET('Cuestionario_Id', $r->Cuestionario_Id);
                $mov->__SET('Evaluado', $r->Evaluado);
                $mov->__SET('Puesto', $r->Puesto);
                $mov->__SET('Evaluacion', $r->Evaluacion);
                $mov->__SET('Cuestionario', $r->Cuestionario);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

     //listar reporte por fecha en el principal
    public function ListarConsolidadoRep($fechaInicio, $fechaFin){
        try {
            $result = array();
            //$stm = $this->pdo->prepare("CALL res_Consolidado('".date('Y-m-d', strtotime($fechaInicio))."','".date('Y-m-d', strtotime($fechaFin))."')");
            $stm = $this->pdo->prepare("CALL res_Consolidado('$fechaInicio','$fechaFin')");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $mov = new Reporte();
                $mov->__SET('Personal_Id', $r->Personal_Id);
                $mov->__SET('Evaluacion_Id', $r->Evaluacion_Id);
                $mov->__SET('Cuestionario_Id', $r->Cuestionario_Id);
                $mov->__SET('Evaluado', $r->Evaluado);
                $mov->__SET('Puesto', $r->Puesto);
                $mov->__SET('Evaluacion', $r->Evaluacion);
                $mov->__SET('Cuestionario', $r->Cuestionario);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarAvance(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call rep_avance()");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluados', $r->Evaluados);
                $res->__SET('Pendiente', $r->Pendiente);
                $res->__SET('TOTAL', $r->TOTAL);
                $res->__SET('Avance', $r->Avance);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
// 4072024
    public function ListarResultadoGenerales() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_resultadoGenerales()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarRankingCompetencia() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_rankingcompetencias()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarRankingComportamiento() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_rankingcomportamientos()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
// 4072024
}
?>
