<?php
class ResultadoModel {
    private $pdo;
    function __CONSTRUCT(){
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar()");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar resultados por fecha
    public function ListarDate($fechaInicio, $fechaFin){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL res_listarevaluadosAll('".date('Y-m-d', strtotime($fechaInicio))."','".date('Y-m-d', strtotime($fechaFin))."')");
            // $stm = $this->pdo->prepare("CALL res_listarevaluadosAll('2017-11-01','2017-12-31')");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $mov = new Resultado();
                $mov->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $mov->__SET('Fecha', date('d-m-Y', strtotime($r->Fecha)));
                $mov->__SET('Evaluador_Id', $r->Evaluador_Id);
                $mov->__SET('Evaluado_Id', $r->Evaluado_Id);
                $mov->__SET('cuestionario_Id', $r->cuestionario_Id);
                $mov->__SET('PuestoEvaluador', $r->PuestoEvaluador);
                $mov->__SET('PuestoEvaluado', $r->PuestoEvaluado);
                $mov->__SET('Evaluador', $r->Evaluador);
                $mov->__SET('Evaluado', $r->Evaluado);
                $mov->__SET('Evaluacion', $r->Evaluacion);
                $mov->__SET('Cuestionario', $r->Cuestionario);
                $mov->__SET('Estado', $r->Estado);
                $mov->__SET('resultado_Id', $r->resultado_Id);
                $result[] = $mov;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //listar de los usuarios

    public function ListarEvaUsu($Evaluador_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listar($Evaluador_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Personal', $r->Personal);
                $res->__SET('nEvaDetTipo', $r->nEvaDetTipo);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $res->__SET('personal_Id', $r->personal_Id);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ObtenerCuestionarioTest($cuestionario_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call cuedet_listar($cuestionario_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('competencia_id', $r->competencia_id);
                $res->__SET('sComNombre', $r->sComNombre);
                $res->__SET('sComTipo', $r->sComTipo);
                $res->__SET('sComDescripcion', $r->sComDescripcion);
                $res->__SET('nComDetOrden', $r->nComDetOrden);
                $res->__SET('competenciadetalle_Id', $r->competenciadetalle_Id);
                $res->__SET('sComDetNombre', $r->sComDetNombre);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function guardarCuestionarioTest(Resultado $data){
        try {
            $resultado_id = 0;
            $stm = $this->pdo->prepare("CALL res_crear(?,?,?,?,?,?,@resultado_id)");
            $stm->execute(array(
                                 $data->__get('nResEvaluaciondetalle_Id'),
                                 $data->__get('nResEvaluador_Id'),
                                 $data->__get('nResEvaluado_Id'),
                                 $data->__get('nResResultado'),
                                 $data->__get('sResFeedback'),
                                 $data->__get('nResEstado')
                                 ));            
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $resultado_id = $r->resultado_id;
            }
            return $resultado_id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function FinalizarCuestionario($resultado_id){
        try {
            $stm = $this->pdo->prepare("CALL res_finaliza($resultado_id)");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    //MOSTRAR DATOS DE LOS RESULTADOS

    public function MostrarResultadoIndividual($resultado_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_individual($resultado_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->Cuestionario);
                $res->__SET('Evaluador', $r->Evaluador);
                $res->__SET('PuestoEvaluador', $r->PuestoEvaluador);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('PuestoEvaluado', $r->PuestoEvaluado);
                $res->__SET('Area', $r->Area);
                // $res->__SET('FechaReingreso', $r->FechaReingreso);
                $res->__SET('Fecha', $r->Fecha);
                $res->__SET('Estado', $r->Estado);
                $res->__SET('Puntaje', $r->Puntaje);
                $res->__SET('Organizacional', $r->Organizacional);
                $res->__SET('Especificas', $r->Especificas);
                $res->__SET('FechaIngreso', $r->FechaIngreso);

                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    //MOSTRAR RESULTADOS DE JEFE

    public function ListarEvaUsuJefe($Evaluador_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_listarevaluados($Evaluador_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Personal', $r->Personal);
                $res->__SET('Puesto', $r->Puesto);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('Cuestionario', $r->sCueCodigo);
                $res->__SET('nResEstado', $r->nResEstado);
                $res->__SET('cuestionario_Id', $r->cuestionario_Id);
                $res->__SET('evaluaciondetalle_Id', $r->evaluaciondetalle_Id);
                $res->__SET('personal_Id', $r->personal_Id);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function MostrarResultadoIndividualJefe($resultado_id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_evaluado($resultado_id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                $res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                $res->__SET('nResEvaluado_Id', $r->nResEvaluado_Id);
                $res->__SET('sPerContrasena', $r->sPerContrasena);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('PuestoEvaluado', $r->PuestoEvaluado);
                $res->__SET('Area', $r->Area);
                $res->__SET('FechaReingreso', $r->FechaReingreso);
                $res->__SET('Estado', $r->Estado);
                $res->__SET('PuntajeAuto', $r->PuntajeAuto);
                $res->__SET('PuntajeJefe', $r->PuntajeJefe);
                $res->__SET('PuntajeEvaluados', $r->PuntajeEvaluados);
                $res->__SET('sResFeedback', $r->sResFeedback);
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    //nuevo MB cabecera del informe de resultados
    public function MostrarResultadoIndividualJefeRep($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("call res_ConsolidadoGeneral($Evaluado_Id,$Evaluacion_Id,$Cuestionario_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $res = new Resultado();
                
                //$res->__SET('resultado_id', $r->resultado_Id);
                $res->__SET('Evaluacion', $r->Evaluacion);
                //$res->__SET('nResEvaluado_Id', $r->nResEvaluado_Id);
                //$res->__SET('sPerContrasena', $r->sPerContrasena);
                $res->__SET('Evaluado', $r->Evaluado);
                $res->__SET('PuestoEvaluado', $r->Puesto);
                $res->__SET('Area', $r->Area);
                $res->__SET('FechaReingreso', $r->Ingreso);
                $res->__SET('Correo', $r->Correo);
                $res->__SET('PuntajeFinal', $r->PuntajeFinal);
                $res->__SET('personal_Id', $r->personal_Id); // TODO: HOY
                
                $result[] = $res;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ModificarFeedback($resultado_Id,$sResFeedback){
        try {
            $stm = $this->pdo->prepare("CALL res_feedback($resultado_Id,'$sResFeedback')");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    
    
}
?>
